#Python script to transform the CPAchecker CSV files into the format i need for further evaluation (OpenOffice Tables)

import csv,re

filename = 'results_bonaire_explBranch_2/productBased.12-02-09.1246.results.VariantsExplicit_firstDefect.csv'

with open(filename, 'r') as f:
    reader = csv.reader(f, delimiter='\t')
    headerrow=reader.next()
    assert headerrow[0]=="sourcefile"
    assert headerrow[1]=="status"
    assert headerrow[2]=="cputime"
    assert headerrow[5]=="reachedSet Size" # number of explored states

    plname = "unknown"
    dictSimulators={}
    dictProducts={}
    try:
        for row in reader:
        	filepath=row[0].split('/')
		#e.g. 	elevator_spec1_product1.cil.c
		#	email_spec6_productSimulator.cil.c
		filename=filepath[len(filepath)-1].split('_')
		if (plname!=filename[0]):
			plname=filename[0]
			print "recognized PL " + plname
		spec=(re.match("spec(.*)",filename[1])).group(1)
		product=(re.match("product(.*).cil.c",filename[2])).group(1)
		status=row[1]
		cputime=row[2]
		states=row[5]
		
		if (product=="Simulator"):
			key = '{0}_{1:04d}'.format(plname ,int(spec))
			dictSimulators.update({key : [plname, spec, product, states, cputime, status]})
		else:
			key = '{0}_{1:04d}_{2:04d}'.format(plname ,int(spec), int(product))
			dictProducts.update({key : [plname, spec, product, states, cputime, status]})

    except csv.Error, e:
	sys.exit('file %s, line %d: %s' % (filename, reader.line_num, e))        
	
    if (len(dictSimulators)>0):
	writer = csv.writer(open('Simulators.csv', 'w'), delimiter='\t')
	for key in sorted(dictSimulators.iterkeys()):
	    value = dictSimulators[key]
	    print "%s: %s" % (key, value)
	    writer.writerow([value[0],value[1],value[2],"NA", "NA", value[3], value[4], "NA", 1, value[5]])

    if (len(dictProducts)>0):
	writer = csv.writer(open('Products.csv', 'w'), delimiter='\t')
	for key in sorted(dictProducts.iterkeys()):
	    value = dictProducts[key]
	    print "%s: %s" % (key, value)
	    writer.writerow([value[0],value[1],value[2],"NA", "NA", value[3], value[4], "NA", 0, value[5]])

